#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my @navitems = (__("CMS Admin"), "/cms/adm", __("Article"), "/cms/adm/articles.cgi");
if ($cgi->{template})
{
    push @navitems, $cgi->{template}, "/cms/adm/articles.cgi?template=$cgi->{template}";
}
elsif ($cgi->{topic} && ($cgi->{topic} =~ /^([^_]+)_(.*)$/))
{
    push @navitems, $1, "/cms/adm/articles.cgi?template=$1";
    push @navitems, $2, "/cms/adm/articles.cgi?topic=$cgi->{topic}";
}
elsif ($cgi->{modate})
{
    push @navitems, $cgi->{modate}, "/cms/adm/articles.cgi?modate=$cgi->{modate}";
}
print $cgi->headerCode(@navitems);

print $cgi->menuCode();

if ($cgi->{delete})
{
    my @ids = split(/\0/, $cgi->{id});
    if (scalar(@ids))
    {
	my $res = MN::CMS::Article->execSQL("delete from mnarticle where id in ('".join("','", @ids)."')");
	$res = MN::News->execSQL("delete from mnnews where id in ('".join("','", @ids)."')");
    }
}

my $filter = "";
if ($cgi->{template})
{
    $filter = "template='$cgi->{template}'";
}
elsif ($cgi->{topic})
{
    $filter = "topic='$cgi->{topic}'";
}
elsif (defined $cgi->{status})
{
    $filter = "status='$cgi->{status}'";
}
elsif ($cgi->{author})
{
    $filter = "author='$cgi->{author}'";
}
elsif ($cgi->{crdate})
{
    $filter = "crdate='$cgi->{crdate}'";
}
elsif ($cgi->{moderator})
{
    $filter = "moderator='$cgi->{moderator}'";
}
elsif ($cgi->{modate})
{
    $filter = "modate='$cgi->{modate}'";
}
elsif ($cgi->{article})
{
    $filter = "id='$cgi->{article}'";
}
my $nbn = MN::CMS::Article->getObjectsCount($filter);
my $npp = 20;
my $fbp = ($nbn / $npp);
my $nbp = int($fbp);
if ($nbp < $fbp || $nbp == 0) { $nbp++ ; }
my $offset = 0;
if ($cgi->{page} > 1)
{
    $offset = ($cgi->{page} - 1) * $npp;
}
my @narticle = MN::CMS::Article->getObjects($filter, "modate desc, motime desc", $npp, $offset);

print '<script language="JavaScript" type="text/javascript">'."\n";
print "<!--\n";
print "function checkarticle(value)\n";
print "{\n";
print "    for (i = 0; i < window.document.article.elements.length; i++) {\n";
print "        window.document.article.elements[i].checked = value;\n";
print "    }\n";
print "}\n";
print "//-->\n";
print "</script>\n";
print "<form method=\"post\">\n";
print "<div class=\"adminpage\">\n";
print '<div class="adminpagelabel">'.__("Page")."</div>\n";
print '<select class="adminpageselect" name="page" onchange="form.submit();">'."\n";
my $i;
for ($i = 1; $i <= $nbp; $i++)
{
    print '<option value="'.$i.'"';
    if ($i == $cgi->{page})
    {
	print " selected";
    }
    print '>'.$i."\n";
}
print "</select>\n";
print "&nbsp;";
printf(__("of %d"), $nbp);
print "</div>\n";
print '<input class="adminformbutton" type="submit" value="'.__("Select all").'" onclick="checkarticle(1);return false">'."\n";
print '<input class="adminformbutton" type="submit" value="'.__("Unselect all").'" onclick="checkarticle(0);return false">'."\n";
if ($cgi->{template})
{
    print '<input type="hidden" name="template" value="'.$cgi->{template}.'">'."\n";
}
elsif ($cgi->{topic})
{
    print '<input type="hidden" name="topic" value="'.$cgi->{topic}.'">'."\n";
}
elsif ($cgi->{modate})
{
    print '<input type="hidden" name="modate" value="'.$cgi->{modate}.'">'."\n";
}
print "</form>\n";
print "<br clear=all>\n";
print "<form method=\"post\" name=\"article\">\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrtopleft">'."</td>\n";
print '<td class="admintbrtop">'."</td>\n";
print '<td class="admintbrtopright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrleft">'."</td>\n";
print '<td class="admintbr">'."\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
print '<tr class="adminheadertr">'."\n";
print '<td class="adminnumbertd2" title="';
if ($nbn > 1)
{
    printf(__("%d articles"), $nbn);
}
else
{
    printf(__("%d article"), $nbn);
}
print '">'."#"."</td>\n";
if ($cgi->{article})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All articles").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Article");
if ($cgi->{article})
{
    print '</a>';
}
print "</td>\n";
if ($cgi->{template})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All sections").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Section");
if ($cgi->{template})
{
    print '</a>';
}
print "</td>\n";
if ($cgi->{topic})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All topics").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Topic");
if ($cgi->{topic})
{
    print '</a>';
}
print "</td>\n";
if (defined $cgi->{status})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All status").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Status");
if (defined $cgi->{status})
{
    print '</a>';
}
print "</td>\n";
if ($cgi->{author})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All authors").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Author");
if ($cgi->{author})
{
    print '</a>';
}
print "</td>\n";
if ($cgi->{crdate})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All dates").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Creation date");
if ($cgi->{moderator})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All moderators").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Moderator");
if ($cgi->{moderator})
{
    print '</a>';
}
print "</td>\n";
if ($cgi->{modate})
{
    print '</a>';
}
if ($cgi->{modate})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All dates").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Last update");
if ($cgi->{modate})
{
    print '</a>';
}
print "</td>\n";
print "</tr>\n";
my $row = "odd";
my $article;
my $tmpl;
my $topic;
my $n = $offset;
foreach $article (@narticle)
{
    print '<tr class="admin'.$row.'tr">'."\n";

    # number
    print '<td class="adminnumbertd">';
    $n++;
    print $n."\n";
    print "</td>\n";

    # article
    print '<td class="admin'.$row.'td">';
    print '<input type="checkbox"  class="adminformcheckbox" name="id" value="'.$article->{id}.'">';
    print '<a href="/cms/article.cgi?cmsid='.$article->{id}.'">'.$article->{name}."</a>\n";
    print "</td>\n";

    # template
    print '<td class="admin'.$row.'td">';
    $tmpl = $article->getTemplate();
    if ($tmpl)
    {
	print '<a href="articles.cgi?template='.$tmpl->{id}.'">'.$tmpl->{name}."</a>\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";

    # topic
    print '<td class="admin'.$row.'td">';
    $topic = $article->getTopic();
    if ($topic)
    {
	print '<a href="articles.cgi?topic='.$topic->{id}.'">'.$topic->{name}."</a>\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";

    # status
    print '<td class="admin'.$row.'td">';
    print '<a href="articles.cgi?status='.$article->{status}.'">'.$article->getStatus()."</a>\n";
    print "</td>\n";

    # author
    print '<td class="admin'.$row.'td">';
    print '<a href="articles.cgi?author='.$article->{author}.'">'.$article->getAuthor(1)."</a>\n";
    print "</td>\n";

    # crdate
    print '<td class="admin'.$row.'td">';
    print '<a href="articles.cgi?crdate='.$article->{crdate}.'">'.$article->getDate()."&nbsp;".$article->getTime()."</a>\n";

    # moderator
    print '<td class="admin'.$row.'td">';
    print '<a href="articles.cgi?moderator='.$article->{moderator}.'">'.$article->getModerator(1)."</a>\n";
    print "</td>\n";

    # modate
    print '<td class="admin'.$row.'td">';
    print '<a href="articles.cgi?modate='.$article->{modate}.'">'.$article->getDate(1)."&nbsp;".$article->getTime(1)."</a>\n";
    print "</td>\n";

    print "</tr>\n";
    $row = $row eq "odd" ? "even" : "odd";
}
print "</table>\n";
print "</td>\n";
print '<td class="admintbrright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrbottomleft">'."</td>\n";
print '<td class="admintbrbottom">'."</td>\n";
print '<td class="admintbrbottomright">'."</td>\n";
print "</tr>\n";
print "</table>\n";

print "<p>\n";
print '<input class="adminformbutton" type="submit" name="delete" value="'.__("Delete").'" '.$cgi->confirmCode("Do you really want to delete selected articles?").">\n";
if ($cgi->{template})
{
    print '<input type="hidden" name="template" value="'.$cgi->{template}.'">'."\n";
}
elsif ($cgi->{topic})
{
    print '<input type="hidden" name="topic" value="'.$cgi->{topic}.'">'."\n";
}
elsif ($cgi->{modate})
{
    print '<input type="hidden" name="modate" value="'.$cgi->{modate}.'">'."\n";
}
print "</form>\n";

print $cgi->footerCode();
