#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

print $cgi->headerCode(__("CMS Admin"), "/cms/adm");

print $cgi->menuCode();

# MyCMS billboard

print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";

print "<caption class=\"adminformtitle\">\n";
print __("MyCMS billboard")."\n";
print "</caption>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformtopleft"></td>'."\n";
print '<td colspan=2 class="adminformtop"></td>'."\n";
print '<td class="adminformtopright"></td>'."\n";
print "</tr>\n";

my @sections = MN::Template->getSections();

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Sections")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="sections.cgi">'.scalar(@sections)."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Topics")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
my $section;
my @topics;
my $nbt = 0;
foreach $section (@sections)
{
    @topics = $section->getTopics();
    $nbt += scalar(@topics);
}
print '<a href="topics.cgi">'.$nbt."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Articles")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="articles.cgi">'.MN::CMS::Article->getObjectsCount()."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Authors")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="users.cgi">'.MN::UserGroup->getObjectsCount("groupid = 'auth'")."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Moderators")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="users.cgi">'.MN::UserGroup->getObjectsCount("groupid = 'mod'")."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformbottomleft"></td>'."\n";
print '<td colspan=2 class="adminformbottom"></td>'."\n";
print '<td class="adminformbottomright"></td>'."\n";
print "</tr>\n";

print "</table>\n";

print $cgi->footerCode();
