#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

my $user = $cgi->getUser();

my $tmpl;

if ($cgi->{delete} && $cgi->{id})
{
    my $template = MN::Template->getTemplate($cgi->{id});
    if ($template)
    {
	$template->delete();
    }
    $cgi->{id} = 0;
}
elsif (!$cgi->{cancel} && $cgi->{custom})
{
    my $template = MN::Template->getTemplate($cgi->{custom});

    if ($cgi->{change})
    {
	rename("$mne->{conf}->{webdir}/img/templates/_$ENV{REMOTE_USER}_.png", "$mne->{conf}->{webdir}/img/templates/$template->{id}.png");
	chmod(0664, "$mne->{conf}->{webdir}/img/templates/$template->{id}.png");
    }
    else
    {
	print $cgi->headerCode(__("Admin"), "/cms/adm", __("Templates"), "/cms/adm/sections.cgi", $cgi->{custom}, "/cms/adm/sections.cgi?id=$cgi->{custom}");
	
	print $cgi->menuCode();
	
	if ($cgi->{iconfile})
	{
	    $cgi->writeFileUpload("iconfile", "$mne->{conf}->{webdir}/img/templates/_$ENV{REMOTE_USER}_.png");
	}
	print "<form method=\"post\" enctype=\"multipart/form-data\">\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";

	print "<caption class=\"adminformtitle\">\n";
	print $cgi->{custom}."\n";
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=4 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Old icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $template->getCode("menu");
	print "</td>\n";
	print '<td class="adminformlabel">'."\n";
	print __("New icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	if ($cgi->{try} && -e "$mne->{conf}->{webdir}/img/templates/_$ENV{REMOTE_USER}_.png")
	{
	    print "<div class=\"newstemplatemenu\">\n";
	    print "<img src=\"$mne->{conf}->{weburl}/img/templates/_$ENV{REMOTE_USER}_.png\">\n";
	    print "</div>\n";
	}
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Icon file")."\n";
	print "</td>\n";
	print '<td colspan=2 class="adminformtd">'."\n";
	print '<input class="adminforminput" type="file" name="iconfile">'."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminformbutton" type="submit" name="try" value="'.__("Try").'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td colspan=4 class="adminformtd">'."\n";
	print '<hr class="adminformseparator">'."\n";
	if ($cgi->{try})
	{
	    print '<input class="adminformbutton" type="submit" name="change" value="'.__("Submit").'">'."\n";
	}
	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	
	print '<input type="hidden" name="custom" value="'.$cgi->{custom}.'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=4 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";
	
	print "<form>\n";
	print $cgi->footerCode();
	exit;
    }
}
elsif ($cgi->{swst})
{
    $tmpl = MN::Template->getTemplate($cgi->{swst});
    $tmpl->modifyAttribute("active", 1 - $tmpl->{active});
}

my @extra = ();
if ($cgi->{id})
{
    push @extra, $cgi->{id}, "/cms/adm/sections.cgi?id=$cgi->{id}";
}
elsif ($cgi->{new})
{
    push @extra, __("New section"), "/cms/adm/sections.cgi?new=1";
}

print $cgi->headerCode(__("CMS Admin"), "/cms/adm", __("Sections"), "/cms/adm/sections.cgi", @extra);

print $cgi->menuCode();

if (!$cgi->{cancel} && ($cgi->{id} || $cgi->{new}))
{
    if ($cgi->{id})
    {
	$tmpl = MN::Template->getObject($cgi->{id});
    }
    if ($cgi->{create})
    {
	if ($tmpl)
	{
	    $cgi->error("Template %s already exists", $cgi->{id});
	}
	$tmpl = new MN::Template();
	$tmpl->updateFrom($cgi);
	$tmpl->{url} = "/cms";
	if ($cgi->{mode})
	{
	    $tmpl->{link_news} = "";
	}
	else
	{
	    $tmpl->{link_news} = '/cms/article.cgi?cmsid='.$tmpl->{id}.'_%s';
	}
	$tmpl->add();
    }
    elsif ($cgi->{modify})
    {
	if (!$tmpl)
	{
	    $cgi->error("Template %s doesn't exist", $cgi->{id});
	}
	$tmpl->updateFrom($cgi);
	if ($cgi->{mode})
	{
	    $tmpl->{link_news} = "";
	}
	else
	{
	    $tmpl->{link_news} = '/cms/article.cgi?cmsid='.$tmpl->{id}.'_%s';
	}
	$tmpl->modify();
    }
    else
    {
	if (!$tmpl)
	{
	    $tmpl = new MN::Template();
	    $tmpl->{lang} = $user->{lang};
	    $tmpl->{link_news} = "tmp";
	}
	print "<form method=\"post\">\n";

	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print "<caption class=\"adminformtitle\">\n";
	if ($cgi->{id})
	{
	    print __("Section")."\n";
	}
	else
	{
	    print __("New section")."\n";
	}
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=2 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Id")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input type="text" name="id" value="'.$tmpl->{id}.'" size="50"';
	if ($cgi->{id})
	{
	    print 'class="roadminforminput" readonly onfocus="blur();"';
	}
	else
	{
	    print 'class="adminforminput"';
	}
	print ">\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
		
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Name")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="name" value="'.$cgi->unquote($tmpl->{name}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Comment")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="comment" value="'.$cgi->unquote($tmpl->{comment}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Language")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $cgi->langSelectorCode($tmpl->{lang}, 0, "admin");
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Mode")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $tmpl->modeSelectorCode();
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td colspan=2 class="adminformtd">'."\n";
	print '<hr class="adminformseparator">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td colspan=2 class="adminformtd">'."\n";
	if ($cgi->{id})
	{
	    print '<input class="adminformbutton" type="submit" name="modify" value="'.__("Modify").'">'."\n";
	    print '<input class="adminformbutton" type="submit" name="delete" value="'.__("Delete").'" '.$cgi->confirmCode("Do you really want to delete template %s?", $cgi->{id}).">\n";
	}
	else
	{
	    print '<input class="adminformbutton" type="submit" name="create" value="'.__("Create").'">'."\n";
	}

	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=2 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";

	print '<hr class="adminformseparator">'."\n";
		

	print "</form>\n";

	print $cgi->footerCode();
	exit;
    }
}

my @tmpls = MN::Template->getSections();
my $nbt = scalar(@tmpls);
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrtopleft">'."</td>\n";
print '<td class="admintbrtop">'."</td>\n";
print '<td class="admintbrtopright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrleft">'."</td>\n";
print '<td class="admintbr">'."\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
print '<tr class="adminheadertr">'."\n";
print '<td class="adminnumbertd2" title="';
if ($nbt > 1)
{
    printf(__("%d sections"), $nbt);
}
else
{
    printf(__("%d section"), $nbt);
}
print '">'."#"."</td>\n";
print '<td class="adminheadertd">'.__("Id")."</td>\n";
print '<td class="adminheadertd">'.__("Status")."</td>\n";
print '<td class="adminheadertd">'.__("Icon")."</td>\n";
print '<td class="adminheadertd">'.__("Topics")."</td>\n";
print '<td class="adminheadertd">'.__("Articles")."</td>\n";
print "</tr>\n";
my $row = "odd";
my $n = 0;
foreach $tmpl (@tmpls)
{
    print '<tr class="admin'.$row.'tr">'."\n";

    # number
    print '<td class="adminnumbertd">';
    $n++;
    print $n."\n";
    print "</td>\n";

    # id
    print '<td class="admin'.$row.'td">';
    print "<a href=\"sections.cgi?id=$tmpl->{id}\">$tmpl->{id}</a>\n";
    print "</td>\n";

    # status
    print '<td class="admin'.$row.'td">';
    print "<a href=\"sections.cgi?swst=$tmpl->{id}\">".$tmpl->getStatusCode()."</a>\n";
    print "</td>\n";

    # icon
    print '<td class="admin'.$row.'td">';
    print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\">\n<tr>\n";
    print "<td>".$tmpl->getCode("admin", $tmpl->{icon_url})."</td>\n";
    print "<td>\n";
    print '<a href="sections.cgi?custom='.$tmpl->{id}.'"><div class="custom2" title="'.__("Customize icon").'"></div></a>'."\n";
    print "</td>\n";
    print "</tr></table>\n";
    print "</td>\n";

    my @topics = $tmpl->getTopics();
    print '<td align="right" class="admin'.$row.'td">';
    print "<a href=\"topics.cgi?template=$tmpl->{id}\">".scalar(@topics)."</a>";
    print "</td>\n";

    print '<td align="right" class="admin'.$row.'td">';
    print "<a href=\"articles.cgi?template=$tmpl->{id}\">".MN::CMS::Article->getObjectsCount("template='$tmpl->{id}'")."</a>";
    print "</td>\n";
    
    print "</tr>\n";
    $row = $row eq "odd" ? "even" : "odd";
}
print "</table>\n";
print "</td>\n";
print '<td class="admintbrright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrbottomleft">'."</td>\n";
print '<td class="admintbrbottom">'."</td>\n";
print '<td class="admintbrbottomright">'."</td>\n";
print "</tr>\n";
print "</table>\n";

print "<p>\n";
print "<form method=\"post\">\n";
print '<input class="adminformbutton" type="submit" name="new" value="'.__("New section").'">'."\n";
print "</form>\n";

print $cgi->footerCode();
