#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

my $user = $cgi->getUser();

my $topic;

if ($cgi->{delete} && $cgi->{tid} && $cgi->{template})
{
    my $topic = MN::Topic->getTopic("$cgi->{template}_$cgi->{tid}");
    if ($topic)
    {
	$topic->delete();
    }
    $cgi->{tid} = 0;
}
elsif ($cgi->{delico})
{
    my $iconfile = "$mne->{conf}->{webdir}/img/topics/$cgi->{delico}.png";
    if (-e $iconfile)
    {
	unlink($iconfile);
    }
}
elsif (!$cgi->{cancel} && $cgi->{custom})
{
    my $topic = MN::Topic->getTopic($cgi->{custom});

    if ($cgi->{change})
    {
	rename("$mne->{conf}->{webdir}/img/topics/_$ENV{REMOTE_USER}_.png", "$mne->{conf}->{webdir}/img/topics/$topic->{id}.png");
	chmod(0664, "$mne->{conf}->{webdir}/img/topics/$topic->{id}.png");
    }
    else
    {
	print $cgi->headerCode(__("Admin"), "/cms/adm", __("Topics"), "/cms/adm/topics.cgi", $cgi->{custom}, "/cms/adm/topics.cgi?id=$cgi->{custom}");
	
	print $cgi->menuCode();
	
	if ($cgi->{iconfile})
	{
	    $cgi->writeFileUpload("iconfile", "$mne->{conf}->{webdir}/img/topics/_$ENV{REMOTE_USER}_.png");
	}
	print "<form method=\"post\" enctype=\"multipart/form-data\">\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";

	print "<caption class=\"adminformtitle\">\n";
	print $cgi->{custom}."\n";
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=4 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Old icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $topic->getCode("menu");
	print "</td>\n";
	print '<td class="adminformlabel">'."\n";
	print __("New icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	if ($cgi->{try} && -e "$mne->{conf}->{webdir}/img/topics/_$ENV{REMOTE_USER}_.png")
	{
	    print "<div class=\"newstopicmenu\">\n";
	    print "<img src=\"$mne->{conf}->{weburl}/img/topics/_$ENV{REMOTE_USER}_.png\">\n";
	    print "</div>\n";
	}
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Icon file")."\n";
	print "</td>\n";
	print '<td colspan=2 class="adminformtd">'."\n";
	print '<input class="adminforminput" type="file" name="iconfile">'."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminformbutton" type="submit" name="try" value="'.__("Try").'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td colspan=4 class="adminformtd">'."\n";
	print '<hr class="adminformseparator">'."\n";
	if ($cgi->{try})
	{
	    print '<input class="adminformbutton" type="submit" name="change" value="'.__("Submit").'">'."\n";
	    my $tmpl = $topic->getTemplate();
	    print '<input type="hidden" name="template" value="'.$tmpl->{id}.'">'."\n";
	}
	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	
	print '<input type="hidden" name="custom" value="'.$cgi->{custom}.'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=4 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";
	
	print "<form>\n";
	print $cgi->footerCode();
	exit;
    }
}

my @extra = ();
if ($cgi->{id})
{
    push @extra, $cgi->{id}, "/cms/adm/topics.cgi?id=$cgi->{id}";
}
elsif ($cgi->{new})
{
    push @extra, __("New topic"), "/cms/adm/topics.cgi?new=1";
}

print $cgi->headerCode(__("CMS Admin"), "/cms/adm", __("Topics"), "/cms/adm/topics.cgi", @extra);

print $cgi->menuCode();

if (!$cgi->{cancel} && ($cgi->{id} || $cgi->{tid} || $cgi->{new}))
{
    if ($cgi->{tid} && $cgi->{template})
    {
	$topic = MN::Topic->getObject("$cgi->{template}_$cgi->{tid}");
    }
    elsif ($cgi->{id})
    {
	$topic = MN::Topic->getObject($cgi->{id});
    }
    if ($cgi->{create})
    {
	if ($topic)
	{
	    $cgi->error("Topic %s already exists", "$cgi->{template}_$cgi->{tid}");
	}
	$topic = new MN::Topic();
	$topic->updateFrom($cgi);
	$topic->{id} = "$cgi->{template}_$cgi->{tid}";
	$topic->add();
    }
    elsif ($cgi->{modify})
    {
	if (!$topic)
	{
	    if ($cgi->{tid} && $cgi->{template})
	    {
		$cgi->error("Topic %s doesn't exist", "$cgi->{template}_$cgi->{tid}");
	    }
	    else
	    {
		$cgi->error("Topic %s doesn't exist", $cgi->{id});
	    }
	}
	$topic->updateFrom($cgi);
	$topic->modify();
    }
    else
    {
	if (!$topic)
	{
	    $topic = new MN::Topic();
	}
	print "<form method=\"post\">\n";

	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print "<caption class=\"adminformtitle\">\n";
	if ($cgi->{id})
	{
	    print __("Topic")."\n";
	}
	else
	{
	    print __("New topic")."\n";
	}
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=2 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Id")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input type="text" name="tid" value="'.$topic->getTopicId.'" size="50"';
	if ($cgi->{id})
	{
	    print 'class="roadminforminput" readonly onfocus="blur();"';
	}
	else
	{
	    print 'class="adminforminput"';
	}
	print ">\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Section")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	my $tmpl;
	if ($cgi->{id})
	{
	    $tmpl = $topic->getTemplate();
	    print '<input type="hidden" name="template" value="'.$tmpl->{id}.'">'.$tmpl->{name}."\n";
	}
	else
	{
	    my @tmpls = MN::Template->getSections();
	    print '<select name="template">'."\n";
	    foreach $tmpl (@tmpls)
	    {
		print '<option value="'.$tmpl->{id}.'"';
		if ($cgi->{template} && $cgi->{template} eq $tmpl->{id})
		{
		    print " selected";
		}
		print '">'.$tmpl->{name}."\n";
	    }
	    print "</select>\n";
	}
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Name")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="name" value="'.$cgi->unquote($topic->{name}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td colspan=2 class="adminformtd">'."\n";
	print '<hr class="adminformseparator">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td colspan=2 class="adminformtd">'."\n";
	if ($cgi->{id})
	{
	    print '<input class="adminformbutton" type="submit" name="modify" value="'.__("Modify").'">'."\n";
	    print '<input class="adminformbutton" type="submit" name="delete" value="'.__("Delete").'" '.$cgi->confirmCode("Do you really want to delete topic %s?", $cgi->{id}).">\n";
	}
	else
	{
	    print '<input class="adminformbutton" type="submit" name="create" value="'.__("Create").'">'."\n";
	}

	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=2 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";

	print '<hr class="adminformseparator">'."\n";
		

	print "</form>\n";

	print $cgi->footerCode();
	exit;
    }
}

my $filter;
my @topics = ();

if ($cgi->{template})
{
    $filter = "id like'$cgi->{template}%'";
}
else
{
    my @tmpls = MN::Template->getSections();
    my $tmpl;
    my @topics2;
    foreach $tmpl (@tmpls)
    {
	@topics2 = $tmpl->getTopics();
	push @topics, @topics2;
    }
}

if ($filter)
{
    @topics = MN::Topic->getObjects($filter);
}

my $nbt = scalar(@topics);
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrtopleft">'."</td>\n";
print '<td class="admintbrtop">'."</td>\n";
print '<td class="admintbrtopright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrleft">'."</td>\n";
print '<td class="admintbr">'."\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
print '<tr class="adminheadertr">'."\n";
print '<td class="adminnumbertd2" title="';
if ($nbt > 1)
{
    printf(__("%d topics"), $nbt);
}
else
{
    printf(__("%d topic"), $nbt);
}
print '">'."#"."</td>\n";
print '<td class="adminheadertd">'.__("Id")."</td>\n";
if ($cgi->{template})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="topics.cgi" title="'.__("All sections").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Section");
if ($cgi->{template})
{
    print '</a>';
}
print "</td>\n";
print '<td class="adminheadertd">'.__("Icon")."</td>\n";
print '<td class="adminheadertd">'.__("Articles")."</td>\n";
print "</tr>\n";
my $row = "odd";
my $n = 0;
my $tmpl;
foreach $topic (@topics)
{
    print '<tr class="admin'.$row.'tr">'."\n";

    # number
    print '<td class="adminnumbertd">';
    $n++;
    print $n."\n";
    print "</td>\n";

    # id
    print '<td class="admin'.$row.'td">';
    print "<a href=\"topics.cgi?id=$topic->{id}\">".$topic->getTopicId()."</a>\n";
    print "</td>\n";

    # section
    $tmpl = $topic->getTemplate();
    print '<td class="admin'.$row.'td">';
    print '<a href="topics.cgi?template='.$tmpl->{id}.'">'.$tmpl->{name}."</a>\n";
    print "</td>\n";

    # icon
    print '<td class="admin'.$row.'td">';
    print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\">\n<tr>\n";
    print "<td>".$topic->getCode()."</td>\n";
    print "<td>\n";
    print '<a href="topics.cgi?delico='.$topic->{id}.'"><div class="reload" title="'.__("Delete icon").'"></div></a><br>'."\n";
    print '<a href="topics.cgi?custom='.$topic->{id}.'"><div class="custom2" title="'.__("Customize icon").'"></div></a>'."\n";
    print "</td>\n";
    print "</tr></table>\n";
    print "</td>\n";

    print '<td align="right" class="admin'.$row.'td">';
    print "<a href=\"articles.cgi?topic=$topic->{id}\">".MN::CMS::Article->getObjectsCount("topic='$topic->{id}'")."</a>";
    print "</td>\n";
    
    print "</tr>\n";
    $row = $row eq "odd" ? "even" : "odd";
}
print "</table>\n";
print "</td>\n";
print '<td class="admintbrright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrbottomleft">'."</td>\n";
print '<td class="admintbrbottom">'."</td>\n";
print '<td class="admintbrbottomright">'."</td>\n";
print "</tr>\n";
print "</table>\n";

print "<p>\n";
print "<form method=\"post\">\n";
print '<input class="adminformbutton" type="submit" name="new" value="'.__("New topic").'">'."\n";
if ($cgi->{template})
{
    print '<input type="hidden" name="template" value="'.$cgi->{template}.'">'."\n";
}
print "</form>\n";

print $cgi->footerCode();
