#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

my @extra = ();
if ($cgi->{login})
{
    push @extra, $cgi->{login}, "/admin/users.cgi?id=$cgi->{login}";
}
elsif ($cgi->{new})
{
    push @extra, __("New user"), "/admin/users.cgi?new=1";
}
print $cgi->headerCode(__("CMS Admin"), "/cms/adm", __("Users"), "/cms/adm/users.cgi", @extra);

print $cgi->menuCode();

my $user;

if (!$cgi->{cancel} && ($cgi->{login} || $cgi->{new}))
{
    if ($cgi->{login})
    {
	$user = MN::User->getObject($cgi->{login});
    }
    if ($cgi->{submit})
    {
	if (!$user)
	{
	    $cgi->error("User %s doesn't exist", $cgi->{login});
	}
	if ($cgi->{auth} != $cgi->{oldauth})
	{
	    $user->setAuth($cgi->{auth});
	}
	if ($cgi->{mod} != $cgi->{oldmod})
	{
	    $user->setMod($cgi->{mod});
	}
	if ($cgi->{auth})
	{
	    $user->setAuthSections($cgi->{authsections});
	}
	else
	{
	    $user->setAuthSections("");
	}
	if ($cgi->{mod})
	{
	    $user->setModSections($cgi->{modsections});
	}
	else
	{
	    $user->setModSections("");
	}
    }
    else
    {
	if (!$user)
	{
	    $user = new MN::User();
	    $user->{lang} = MN::CGI::getUser()->{lang};
	    $user->setAllDisplay();
	    $user->{newsperpage} = $mne->getNPP();
	}
	print "<form method=\"post\">\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=4 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Login")."\n";
	print "</td>\n";
	print '<td colspan=3 class="adminformtd">'."\n";
	print '<input type="text" name="login" value="'.$cgi->{login}.'" size="50"';
	print ' class="roadminforminput" readonly onfocus="blur();">';
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
		
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Name")."\n";
	print "</td>\n";
	print '<td colspan=3 class="adminformtd">'."\n";
	print '<input type="text" name="firstname" value="'.$cgi->unquote($user->getLongName()).'" size="50" class="roadminforminput" readonly onfocus="blur();">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
		
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";

	print '<td class="adminformlabel">'."\n";
	print __("Author")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $user->authSelectorCode();
	print "</td>\n";

	print '<td class="adminformlabel">'."\n";
	print __("Moderator")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $user->modSelectorCode();
	print "</td>\n";

	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";

	print '<td class="adminformlabel">'."\n";
	print __("Sections")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $user->authSectionsSelectorCode();
	print "</td>\n";

	print '<td class="adminformlabel">'."\n";
	print __("Sections")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $user->modSectionsSelectorCode();
	print "</td>\n";

	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformtd" colspan=4>'."\n";
	print '<hr class="adminformseparator">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformtd" colspan=4>'."\n";
	print '<input class="adminformbutton" type="submit" name="submit" value="'.__("Submit").'">'."\n";
	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=4 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";
	
	print "</table>\n";
	print "</form>\n";
	print $cgi->footerCode();
	exit;
    }
}

my @users = MN::User->getObjects("", "login");
my $nbu = scalar(@users);
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrtopleft">'."</td>\n";
print '<td class="admintbrtop">'."</td>\n";
print '<td class="admintbrtopright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrleft">'."</td>\n";
print '<td class="admintbr">'."\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
print '<tr class="adminheadertr">'."\n";
print '<td class="adminnumbertd2" title="';
if ($nbu > 1)
{
    printf(__("%d users"), $nbu);
}
else
{
    printf(__("%d user"), $nbu);
}
print '">'."#"."</td>\n";
print '<td class="adminheadertd">'.__("Login")."</td>\n";
print '<td class="adminheadertd">'.__("Name")."</td>\n";
print '<td class="adminheadertd">'.__("E-mail address")."</td>\n";
print '<td class="adminheadertd">'.__("Author")."</td>\n";
print '<td class="adminheadertd">'.__("Moderator")."</td>\n";
print "</tr>\n";
my $row = "odd";
my $tmpl;
my $n = 0;
my $res;
my $yes = __("Yes");
my $tmpls;
my $tmpl;

foreach $user (@users)
{
    print '<tr class="admin'.$row.'tr">'."\n";

    # number
    print '<td class="adminnumbertd">';
    $n++;
    print $n."\n";
    print "</td>\n";

    # login
    print '<td class="admin'.$row.'td">';
    print "<a href=\"users.cgi?login=$user->{login}\">$user->{login}</a>\n";
    print "</td>\n";

    # name
    print '<td class="admin'.$row.'td">';
    print $user->getLongName();
    print "\n";
    print "</td>\n";

    # mail
    print '<td class="admin'.$row.'td">';
    if ($user->{mail})
    {
	print "<a href=\"maito:$user->{mail}\">$user->{mail}</a>\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";

    # author
    print '<td class="admin'.$row.'td">';
    $res = $user->isAuthor();
    if ($res eq $yes)
    {
	$tmpls = $user->getAuthSections();
	foreach $tmpl (@{$tmpls})
	{
	    print "<div class=\"admintemplate\">\n";
	    print "<a href=\"/admin/templates.cgi?id=$tmpl->{id}\">$tmpl->{name}</a>\n";
	    print "</div>\n";
	    $res = "";
	}
    }
    if ($res)
    {
	print $res;
    }
    print "</td>\n";

    
    # moderator
    print '<td class="admin'.$row.'td">';
    $res = $user->isModerator();
    if ($res eq $yes)
    {
	$tmpls = $user->getModSections();
	foreach $tmpl (@{$tmpls})
	{
	    print "<div class=\"admintemplate\">\n";
	    print "<a href=\"/admin/templates.cgi?id=$tmpl->{id}\">$tmpl->{name}</a>\n";
	    print "</div>\n";
	    $res = "";
	}
    }
    if ($res)
    {
	print $res;
    }
    print "</td>\n";

    print "</tr>\n";
    $row = $row eq "odd" ? "even" : "odd";
}
print "</table>\n";
print "</td>\n";
print '<td class="admintbrright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrbottomleft">'."</td>\n";
print '<td class="admintbrbottom">'."</td>\n";
print '<td class="admintbrbottomright">'."</td>\n";
print "</tr>\n";
print "</table>\n";

print $cgi->footerCode();
