#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my $user = $cgi->getUser();
my @navitems = ();

my $article = MN::CMS::Article->getObject($cgi->{cmsid});
if (!$article)
{
    $cgi->error("Article %s doesn't exist", $cgi->{cmsid});
}

my $tmpl = $article->getTemplate();

if (!$tmpl)
{
    $cgi->error("Template %s doesn't exist", $article->{template})
}

if ($user && !MN::Subscr->getObject($tmpl->{id}, $user->{login}))
{
    push @navitems, __("Other sites"), "/other.cgi";
}
push @navitems, $tmpl->{name}, "/template.cgi?id=$tmpl->{id}";

if ($article->{topic})
{
    my $topic = $article->getTopic();

    if (!$topic)
    {
	$cgi->error("Topic %s doesn't exist", $article->{topic});
    }
    push @navitems, $topic->{name}, "/topic.cgi?id=$topic->{id}";
}
my $max = 60;
my $name = $article->{name};
if (length($name) > $max)
{
    $name = substr($name, 0, $max);
    $name =~ s/\s\S*$/\.\.\./;
}
push @navitems, $name, "/cms/article.cgi?cmsid=$article->{id}";

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

my $access = 0;
my $user = $cgi->getUser();
if ($article->{status} == 4)
{
    $access = 1;
}
else
{
    if ($user && ($user->isAdmin() || $user->{login} eq $article->{author} || $user->{login} eq $article->{moderator}))
    {
	$access = 1;
    }    
}

if ($access)
{
    my $url = "";
    if ($user)
    {
	if ($user->{login} eq $article->{author})
	{
	    $url = $mne->{conf}->{weburl}.'/cms/auth/article.cgi?id='.$article->{id};
	}
	elsif ($user->{login} eq $article->{moderator})
	{
	    $url = $mne->{conf}->{weburl}.'/cms/mod/article.cgi?id='.$article->{id};
	}
	elsif ($user->isAdmin())
	{
	    $url = $mne->{conf}->{weburl}.'/cms/adm/articles.cgi?article='.$article->{id};
	}
    }
    print $article->getCode("", $url);
}
else
{
    $cgi->error("Article is not available for the moment");
}

print $cgi->footerCode();
