#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my $article;
my $weblog = 0;

if ($cgi->{cancel1})
{
    $cgi->redirect("article.cgi?id=$cgi->{id}");
}
elsif ($cgi->{cancel})
{
    $cgi->redirect("articles.cgi");
}
elsif ($cgi->{publish} && $cgi->{id})
{
    $article = MN::CMS::Article->getObject($cgi->{id});
    if ($article)
    {
	my $res = $article->publish($cgi->{comment});

	if ($res)
	{
	    $cgi->setAlert($res);
	}
	else
	{
	    $cgi->setAlert("Article %s has been published", $cgi->{id});
	}
    } 
}
elsif ($cgi->{submod} && $cgi->{id})
{
    $article = MN::CMS::Article->getObject($cgi->{id});
    if ($article)
    {
	my $res = $article->submod($cgi->{comment});

	if ($res)
	{
	    $cgi->setAlert($res);
	}
	else
	{
	    $cgi->setAlert("Article %s has been submitted to moderators", $cgi->{id});
	}
    } 
}

my @navitems = (__("Author"), "/cms/auth", __("Articles"), "/cms/auth/articles.cgi");

if ($cgi->{id})
{
    $article = MN::CMS::Article->getObject($cgi->{id});
}
else
{
    $article = new MN::CMS::Article();
    $article->updateFrom($cgi);
}

if ($cgi->{validate})
{
    $article->updateFrom($cgi);
    if (!$article->{id})
    {
	$article->setId();
	$article->add();
    }
    else
    {
	if ($article->{status} == 4) # published
	{
	    $article->{status} = 1; # modified
	}
	$article->setMoDate();
	$article->modify();
    }
    $cgi->redirect("article.cgi?id=$article->{id}");
}

if ($article->{id})
{
    push @navitems, $article->{name}, "/cms/auth/article.cgi?id=$article->{id}";
    if ($cgi->{edit})
    {
	push @navitems, __("Edit article"), "/cms/auth/article.cgi?id=$article->{id}&edit=1";
    }
}
else
{
    push @navitems, __("New article"), "/cms/auth/article.cgi?edit=1";
}

my $user = $cgi->getUser();
if ($article->{id} && $article->{author} ne $user->{login})
{
    $cgi->error("You are not the author of this article");
}

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

if ($cgi->{edit})
{
    print $article->getJSCode();
}

print "<form method=\"post\" name=\"arted\">\n";

if ($cgi->{edit})
{
    my $jscode = " onselect='storeCaret(this);' onclick='storeCaret(this);' onkeyup='storeCaret(this);' ondbclick='storeCaret(this);'";

    if ($article->{id})
    {
	print_form(1);
    }
    else
    {
	print '<input type="hidden" name="edit" value="1">'."\n";

	# Section
	print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\" class=\"form\">\n";
	print "<caption class=\"formtitle\">\n";
	print __("New article")."\n";
	print "</caption>\n";
	print '<tr class="formtr">'."\n";
	print '<td class="formtopleft"></td>'."\n";
	print '<td colspan=3 class="formtop"></td>'."\n";
	print '<td class="formtopright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="formtr">'."\n";
	print '<td class="formleft"></td>'."\n";
	print '<td class="formlabel">'."\n";
	print __("Section")."\n";
	print "</td>\n";
	print '<td width="100%" class="formtd">'."\n";
	print $user->authSectionSelectorCode($article->{template});
	print "</td>\n";
	print '<td class="formtd">'."\n";
	print '<input class="adminformbutton2" type="submit" name="validate" value="'.__("Submit").'">'."\n";
	print "</td>\n";
	print '<td class="formright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="formtr">'."\n";
	print '<td class="formleft"></td>'."\n";
	print '<td class="formlabel">'."\n";
	print __("Topic")."\n";
	print "</td>\n";
	print '<td width="100%" class="formtd">'."\n";
	my $tmpl = $cgi->{template} || $user->{defsection};
	print $user->authTopicSelectorCode($tmpl);
	print "</td>\n";
	print '<td class="formtd">'."\n";
	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	print "</td>\n";
	print '<td class="formright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="formtr">'."\n";
	print '<td class="formbottomleft"></td>'."\n";
	print '<td colspan=3 class="formbottom"></td>'."\n";
	print '<td class="formbottomright"></td>'."\n";
	print "</tr>\n";
    }

    # Name
    print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\" class=\"form\">\n";
    print "<caption class=\"formtitle\">\n";
    print __("Name")."\n";
    print "</caption>\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formtopleft"></td>'."\n";
    print '<td class="formtop"></td>'."\n";
    print '<td class="formtopright"></td>'."\n";
    print "</tr>\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td width="100%" class="formtd">'."\n";
    print '<input class="artedname" type="text" name="name" value="'.$cgi->unquote($article->{name}).'" size="100">'."\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formbottomleft"></td>'."\n";
    print '<td class="formbottom"></td>'."\n";
    print '<td class="formbottomright"></td>'."\n";
    print "</tr>\n";
    
    # Abstract
    print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\" class=\"form\">\n";
    print "<caption class=\"formtitle\">\n";
    if ($weblog)
    {
	print __("Content")."\n";
    }
    else
    {
	print __("Abstract")."\n";
    }
    print "</caption>\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formtopleft"></td>'."\n";
    print '<td class="formtop"></td>'."\n";
    print '<td class="formtopright"></td>'."\n";
    print "</tr>\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formtd">'."\n";
    print $article->styleSelectorCode(1);
    if ($article->{id})
    {
	print $article->linkSelectorCode(1);
    }
    print $article->miscSelectorCode(1);
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td width="100%" class="formtd">'."\n";
    if ($weblog)
    {
	print '<textarea class="artedabstract" name="abstract" rows="20" cols="80"'.$jscode.'>'."\n";
    }
    else
    {
	print '<textarea class="artedabstract" name="abstract" rows="5" cols="80"'.$jscode.'>'."\n";
    }
    print  $article->{abstract};
    print "</textarea>\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formbottomleft"></td>'."\n";
    print '<td class="formbottom"></td>'."\n";
    print '<td class="formbottomright"></td>'."\n";
    print "</tr>\n";
    
    # Body
    if (!$weblog)
    {
	print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\" class=\"form\">\n";
	print "<caption class=\"formtitle\">\n";
	print __("Content")."\n";
	print "</caption>\n";
	print '<tr class="formtr">'."\n";
	print '<td class="formtopleft"></td>'."\n";
	print '<td width="100%" class="formtop"></td>'."\n";
	print '<td class="formtopright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="formtr">'."\n";
	print '<td class="formleft"></td>'."\n";
	print '<td class="formtd">'."\n";
	print $article->styleSelectorCode();
	if ($article->{id})
	{
	    print $article->linkSelectorCode();
	    print $article->noteSelectorCode();
	    print $article->imageSelectorCode();
	}
	print $article->miscSelectorCode();
	print "</td>\n";
	print '<td class="formright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="formtr">'."\n";
	print '<td class="formleft"></td>'."\n";
	print '<td class="formtd">'."\n";
	print '<textarea class="artedbody" name="body" rows="20" cols="80"'.$jscode.'>'."\n";
	print  $article->{body};
	print "</textarea>\n";
	print "</td>\n";
	print '<td class="formright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="formtr">'."\n";
	print '<td class="formbottomleft"></td>'."\n";
	print '<td class="formbottom"></td>'."\n";
	print '<td class="formbottomright"></td>'."\n";
	print "</tr>\n";	
	print "</table>\n";
    }
    print "</form>\n";
}
else
{
    print_form();

    print "<p>\n";

    print $article->getCode("", $mne->{conf}->{weburl}.'/cms/article.cgi?cmsid='.$article->{id});

    print "</form>\n";

    print "<table width=\"100%\">\n";
    print "<tr valign=\"top\">\n";

    print "<td>\n";
    my $links = $article->getLinks();
    my $link;
    my $nbn = scalar(@{$links});
    print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
    print "<caption class=\"admintbtitle\">\n";
    print __("Links")."\n";
    print "</caption>\n";
    print '<tr class="admintbr">'."\n";
    print '<td class="admintbrtopleft">'."</td>\n";
    print '<td class="admintbrtop">'."</td>\n";
    print '<td class="admintbrtopright">'."</td>\n";
    print "</tr>\n";
    print '<tr class="admintbr">'."\n";
    print '<td class="admintbrleft">'."</td>\n";
    print '<td class="admintbr">'."\n";
    print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
    print '<tr class="adminheadertr">'."\n";
    print '<td class="adminnumbertd2" title="';
    if ($nbn > 1)
    {
	printf(__("%d links"), $nbn);
    }
    else
    {
	printf(__("%d link"), $nbn);
    }
    print '">'."#"."</td>\n";
    print '<td class="adminheadertd">'.__("Name")."</td>\n";
    print "</tr>\n";
    my $n = 0;
    my $row = "odd";

    foreach $link (@{$links})
    {
	print '<tr class="admin'.$row.'tr">'."\n";
	
	# number
	print '<td class="adminnumbertd">';
	$n++;
	print $n."\n";
	print "</td>\n";

	# name
	print '<td class="admin'.$row.'td">';
	print '<a href="/cms/auth/link.cgi?cmsid='.$link->{id}.'">'.$link->getShortName()."</a>\n";
	print "</td>\n";
	
	print "</tr>\n";
	$row = $row eq "odd" ? "even" : "odd";
    }
    print "</table>\n";
    print "</td>\n";
    print '<td class="admintbrright">'."</td>\n";
    print "</tr>\n";
    print '<tr class="admintbr">'."\n";
    print '<td class="admintbrbottomleft">'."</td>\n";
    print '<td class="admintbrbottom">'."</td>\n";
    print '<td class="admintbrbottomright">'."</td>\n";
    print "</tr>\n";
    print "</table>\n";
    if ($article->{status} != 2 && $article->{status} != 3)
    {
	print "<p>\n";
	print "<form method=\"post\" action=\"link.cgi\">\n";
	print '<input class="adminformbutton" type="submit" name="" value="'.__("New link").'">'."\n";
	print '<input type="hidden" name="article" value="'.$article->{id}.'">'."\n";
	print "</form>\n";
    }
    print "</td>\n";

    if (!$weblog)
    {
	# images
	print "<td>\n";
	my $images = $article->getImages();
	my $image;
	my $nbn = scalar(@{$images});
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
	print "<caption class=\"admintbtitle\">\n";
	print __("Images")."\n";
	print "</caption>\n";
	print '<tr class="admintbr">'."\n";
	print '<td class="admintbrtopleft">'."</td>\n";
	print '<td class="admintbrtop">'."</td>\n";
	print '<td class="admintbrtopright">'."</td>\n";
	print "</tr>\n";
	print '<tr class="admintbr">'."\n";
	print '<td class="admintbrleft">'."</td>\n";
	print '<td class="admintbr">'."\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
	print '<tr class="adminheadertr">'."\n";
	print '<td class="adminnumbertd2" title="';
	if ($nbn > 1)
	{
	    printf(__("%d images"), $nbn);
	}
	else
	{
	    printf(__("%d image"), $nbn);
	}
	print '">'."#"."</td>\n";
	print '<td class="adminheadertd">'.__("Name")."</td>\n";
	print "</tr>\n";
	my $n = 0;
	my $row = "odd";
	
	foreach $image (@{$images})
	{
	    print '<tr class="admin'.$row.'tr">'."\n";
	    
	    # number
	    print '<td class="adminnumbertd">';
	    $n++;
	    print $n."\n";
	    print "</td>\n";
	    
	    # name
	    my $name = $image->getShortName();
	    print '<td class="admin'.$row.'td">';
	    print '<a href="/cms/auth/image.cgi?cmsid='.$image->{id}.'">'.$name."</a>\n";
	    print "</td>\n";
	    
	    print "</tr>\n";
	    $row = $row eq "odd" ? "even" : "odd";
	}
	print "</table>\n";
	print "</td>\n";
	print '<td class="admintbrright">'."</td>\n";
	print "</tr>\n";
	print '<tr class="admintbr">'."\n";
	print '<td class="admintbrbottomleft">'."</td>\n";
	print '<td class="admintbrbottom">'."</td>\n";
	print '<td class="admintbrbottomright">'."</td>\n";
	print "</tr>\n";
	print "</table>\n";
	print "<p>\n";
	if ($article->{status} != 2 && $article->{status} != 3)
	{
	    print "<form method=\"post\" action=\"image.cgi\">\n";
	    print '<input class="adminformbutton" type="submit" name="" value="'.__("New image").'">'."\n";
	    print '<input type="hidden" name="article" value="'.$article->{id}.'">'."\n";
	    print "</form>\n";
	}
	print "</td>\n";

	# notes
	print "<td>\n";
	my $notes = $article->getNotes();
	my $note;
	my $nbn = scalar(@{$notes});
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
	print "<caption class=\"admintbtitle\">\n";
	print __("Notes")."\n";
	print "</caption>\n";
	print '<tr class="admintbr">'."\n";
	print '<td class="admintbrtopleft">'."</td>\n";
	print '<td class="admintbrtop">'."</td>\n";
	print '<td class="admintbrtopright">'."</td>\n";
	print "</tr>\n";
	print '<tr class="admintbr">'."\n";
	print '<td class="admintbrleft">'."</td>\n";
	print '<td class="admintbr">'."\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
	print '<tr class="adminheadertr">'."\n";
	print '<td class="adminnumbertd2" title="';
	if ($nbn > 1)
	{
	    printf(__("%d notes"), $nbn);
	}
	else
	{
	    printf(__("%d note"), $nbn);
	}
	print '">'."#"."</td>\n";
	print '<td class="adminheadertd">'.__("Name")."</td>\n";
	print "</tr>\n";
	my $n = 0;
	my $row = "odd";
	
	foreach $note (@{$notes})
	{
	    print '<tr class="admin'.$row.'tr">'."\n";
	    
	    # number
	    print '<td class="adminnumbertd">';
	    $n++;
	    print $n."\n";
	    print "</td>\n";
	    
	    # name
	    print '<td class="admin'.$row.'td">';
	    print '<a href="/cms/auth/note.cgi?cmsid='.$note->{id}.'">'.$note->getShortContent()."</a>\n";
	    print "</td>\n";
	    
	    print "</tr>\n";
	    $row = $row eq "odd" ? "even" : "odd";
	}
	print "</table>\n";
	print "</td>\n";
	print '<td class="admintbrright">'."</td>\n";
	print "</tr>\n";
	print '<tr class="admintbr">'."\n";
	print '<td class="admintbrbottomleft">'."</td>\n";
	print '<td class="admintbrbottom">'."</td>\n";
	print '<td class="admintbrbottomright">'."</td>\n";
	print "</tr>\n";
	print "</table>\n";
	print "<p>\n";
	if ($article->{status} != 2 && $article->{status} != 3)
	{
	    print "<form method=\"post\" action=\"note.cgi\">\n";
	    print '<input class="adminformbutton" type="submit" name="" value="'.__("New note").'">'."\n";
	    print '<input type="hidden" name="article" value="'.$article->{id}.'">'."\n";
	    print "</form>\n";
	}
	print "</td>\n";
    }
    print "</tr>\n";
    print "</table>\n";
}

print $cgi->footerCode();

sub print_form
{
    my $mode = shift || "";

    print '<input type="hidden" name="id" value="'.$article->{id}.'">'."\n";

    print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\"class=\"form\">\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formtopleft"></td>'."\n";
    print '<td colspan=5 class="formtop"></td>'."\n";
    print '<td class="formtopright"></td>'."\n";
    print "</tr>\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td width="20%" class="formlabel">'."\n";
    print __("Article")."\n";
    print "</td>\n";
    print '<td width="20%" class="formtd">'."\n";
    print $article->{id};
    print "</td>\n";
    print '<td width="20%" class="formlabel">'."\n";
    print __("Status")."\n";
    print "</td>\n";
    print '<td width="20%" class="formtd">'."\n";
    print $article->getStatus();
    print "</td>\n";
    print '<td width="20%" class="formtd">'."\n";
    if ($mode)
    {
	print '<input class="adminformbutton2" type="submit" name="validate" value="'.__("Submit").'">'."\n";
    }
    elsif ($article->{status} == 0 || 
	$article->{status} == 1 ||
	$article->{status} == 4)
    {
	print '<input class="adminformbutton2" type="submit" name="edit" value="'.__("Edit article").'">'."\n";
	
    }
    else
    {
	print "&nbsp;";
    }
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Author")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $article->getAuthor();
    print "</td>\n";
    print '<td class="formlabel">'."\n";
    print __("Moderator")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $article->getModerator();
    print "</td>\n";
    print '<td class="formtd">'."\n";
    my $tmpl = $article->getTemplate();
    if (!$tmpl->{link_news})
    {
	$weblog = 1;
    }
    if (!$mode &&
	($article->{status} == 0 || 
	$article->{status} == 1))
    {
	if ($tmpl->isModerated())
	{
	    print '<input class="adminformbutton2" type="submit" name="submod" value="'.__("Submit to moderators").'" onclick="return confirm(\''.__("Confirm submission").'\')">'."\n";
	}
	else
	{
	    print '<input class="adminformbutton2" type="submit" name="publish" value="'.__("Publish article").'" onclick="return confirm(\''.__("Confirm publication").'\')">'."\n";
	}
    }
    else
    {
	print "&nbsp;";
    }
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Creation date")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $article->getDate()."&nbsp;".$article->getTime();
    print "</td>\n";
    print '<td class="formlabel">'."\n";
    print __("Last update")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $article->getDate(1)."&nbsp;".$article->getTime(1);
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print "&nbsp;";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Section")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    if ($tmpl)
    {
	print $tmpl->{name}."\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";
    print '<td class="formlabel">'."\n";
    print __("Topic")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    if ($mode)
    {
	print $user->authTopicSelectorCode($article->{template}, $article->{topic});
    }
    else
    {
	my $topic = $article->getTopic();
	if ($topic)
	{
	    print $topic->{name}."\n";
	}
	else
	{
	    print "&nbsp;\n";
	}
    }
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print '<input class="adminformbutton2" type="submit" name="cancel'.$mode.'" value="'.__("Cancel").'">'."\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    if (!$mode)
    {
	print '<tr class="formtr">'."\n";
	print '<td class="formleft"></td>'."\n";
	print '<td colspan=5 class="formtd" align="center">'."\n";
	print "<b>".__("Comment")."</b>\n";
	print "</td>\n";
	print '<td class="formright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="formtr">'."\n";
	print '<td class="formleft"></td>'."\n";
	print '<td colspan=5 class="formtd">'."\n";
	print '<textarea name="comment" class="artedbody" rows="2" cols="80">'."\n";
	print "</textarea>\n";
	print "</td>\n";
	print '<td class="formright"></td>'."\n";
	print "</tr>\n";
    }

    print '<tr class="formtr">'."\n";
    print '<td class="formbottomleft"></td>'."\n";
    print '<td colspan=5 class="formbottom"></td>'."\n";
    print '<td class="formbottomright"></td>'."\n";
    print "</tr>\n";
    print "</table>\n";
}
