#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

my $image;
my $article;
my $newimage = 0;
my $source;
my $tmpfile;
if ($cgi->{upload} && $cgi->{imgfile} && $cgi->{imgfile} =~ /([^\/\\]+\.(gif|jpe?g|png))$/i)
{
    my $user = $cgi->getUser();
    $image = new MN::CMS::Image();
    $image->updateFrom($cgi);
    if (!$image->{align})
    {
	$image->{align} = "left";
    }
    $article = $image->getArticle();
    $image->clearTmp($user->{login});
    my $filename = $user->{login}."_".time().".png";
    $tmpfile = $mne->{conf}->{webdir}."/cms/img/tmp/".$filename;
    $source = $mne->{conf}->{weburl}."/cms/img/tmp/".$filename;
    $cgi->writeFileUpload("imgfile", $tmpfile);
    $image->getGeometryFrom($tmpfile);
    if ($cgi->{newimage})
    {
	$newimage = 1;
    }
}
elsif ($cgi->{add} || $cgi->{modify} || $cgi->{delete})
{
    $image = new MN::CMS::Image();
    $image->updateFrom($cgi);
    $article = $image->getArticle();
    if ($cgi->{delete})
    {
	$image->delete();
    }
    elsif ($cgi->{add})
    {
	$image->copyFrom($cgi->{tmpfile});
	$image->buildMini();
	$image->add();
    }
    else
    {
	if ($cgi->{tmpfile})
	{
	    $image->copyFrom($cgi->{tmpfile});
	}
	if ($cgi->{tmpfile} || $image->{oldwidth} && $image->{oldwidth} != $image->{width})
	{
	    $image->buildMini();
	}
	$image->modify();
    }
    if ($article->{status} == 4) # published
    {
	$article->{status} = 1; # modified
    }
    $article->setMoDate();
    $article->modify();
    $cgi->redirect("article.cgi?id=$article->{id}");
}
elsif ($cgi->{cmsid})
{
    $image = MN::CMS::Image->getObject($cgi->{cmsid});
    if ($image)
    {
	$article = $image->getArticle();
    }
    $source = $mne->{conf}->{weburl}."/cms/img/maxi/".$image->{id}.".png";
}
elsif ($cgi->{article})
{
    $image = new MN::CMS::Image();
    $article = MN::CMS::Article->getArticle($cgi->{article});
    $image->{id} = $article->getNextImageId();
    $newimage = 1;
}
else
{
    $image = new MN::CMS::Image();
    $image->updateFrom($cgi);
    $article = $image->getArticle();
    if ($image->{tmpfile})
    {
	$tmpfile = $image->{tmpfile};
	$source = $tmpfile;
	$source =~ s/^$mne->{conf}->{webdir}/$mne->{conf}->{weburl}/;
    }
    if ($cgi->{newimage})
    {
	$newimage = 1;
    }
    elsif (!$source)
    {
	$source = $mne->{conf}->{weburl}."/cms/img/maxi/".$image->{id}.".png";
    }
}

if ($cgi->{cancel})
{
    $image = new MN::CMS::Image();
    $image->updateFrom($cgi);
    $article = $image->getArticle();
    $cgi->redirect("article.cgi?id=$article->{id}");
}

my @navitems = (__("Author"), "/cms/auth", __("Articles"), "/cms/auth/articles.cgi");

push @navitems, $article->{name}, "/cms/auth/article.cgi?id=$article->{id}";

if ($newimage)
{
    push @navitems, __("New image"), "/cms/auth/image.cgi?article=$article->{id}";
}
else
{
    push @navitems, sprintf(__("Image %s"), $image->{id}), "/cms/auth/image.cgi?cmsid=$image->{id}";
}

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

my $ro = 0;
if ($article->{status} == 2 || $article->{status} == 3)
{
    $ro = 1;
}

if (!$ro)
{
    print $image->getJSCode();
}

print "<form method=\"post\" name=\"imageed\" enctype=\"multipart/form-data\">\n";

# Name
print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\" class=\"form\">\n";
print "<caption class=\"formtitle\">\n";
if ($newimage)
{
    print __("New image")."\n";
}
else
{
    print sprintf(__("Image %s"), $image->{id})."\n";
}
print "</caption>\n";
print '<tr class="formtr">'."\n";
print '<td class="formtopleft"></td>'."\n";
print '<td colspan=6 class="formtop"></td>'."\n";
print '<td class="formtopright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Image")."\n";
print "</td>\n";
print '<td width="100%" class="formtd">'."\n";
print '<input type="hidden" name="id" value="'.$image->{id}.'">'.$image->{id}."\n";
print "</td>\n";
print '<td class="formlabel">'."\n";
print __("Image file")."\n";
print "</td>\n";
print '<td  colspan=2 class="adminformtd">'."\n";
if ($ro)
{
    print "&nbsp;\n";
}
else
{
    print '<input type="file" name="imgfile" class="adminformfile">'."\n";
}
print '</td>'."\n";
print '<td class="adminformtd">'."\n";
if ($ro)
{
    print "&nbsp;\n";
}
else
{
    print '<input class="adminformbutton" type="submit" name="upload" value="'.__("Import").'">'."\n";
}
print '</td>'."\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

if ($source)
{
    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Name")."\n";
    print "</td>\n";
    print '<td width="100%" colspan=5 class="formtd">'."\n";
    if ($ro)
    {
	print $image->{name}."\n";
    }
    else
    {
	print '<input class="artedname" type="text" name="name" value="'.$cgi->unquote($image->{name}).'" size="100">'."\n";
    }
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Width")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print '<input type="text" name="width" value="'.$image->{width}.'" size="10"';
    if ($ro)
    {
	print ' class="roadminforminput" readonly onfocus="blur();">'."\n";
    }
    else
    {
	print ' class="adminforminput" onchange="resizeImg(this,0)">'."\n";
    }
    print "</td>\n";
    print '<td class="formlabel">'."\n";
    print __("Width")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print '<input class="roadminforminput" readonly onfocus="blur();" type="text" name="swidth" value="'.$image->{swidth}.'" size="10">'."\n";
    print "</td>\n";
    print '<td rowspan=2 class="formlabel">'."\n";
    print __("Scale")."\n";
    print "</td>\n";
    print '<td rowspan=2 class="formtd">'."\n";
    print $image->scaleSelectorCode($ro);
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Height")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print '<input type="text" name="height" value="'.$image->{height}.'" size="10"';
    if ($ro)
    {
	print ' class="roadminforminput" readonly onfocus="blur();">'."\n";
    }
    else
    {
	print ' class="adminforminput" onchange="resizeImg(this,1)">'."\n";
    }
    print "</td>\n";
    print '<td class="formlabel">'."\n";
    print __("Height")."\n";
    print "</td>\n";
    print '<td colspan=3 class="formtd">'."\n";
    print '<input class="roadminforminput" readonly onfocus="blur();" type="text" name="sheight" value="'.$image->{sheight}.'" size="10">'."\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Align")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $image->alignSelectorCode($ro);
    print "</td>\n";
    print '<td class="formlabel">'."\n";
    print __("Link")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $image->linkSelectorCode($ro);
    print "</td>\n";
    print '<td class="formlabel">'."\n";
    print __("Border")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $image->borderSelectorCode($ro);
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

}
print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformtd" colspan=6>'."\n";
print '<hr class="adminformseparator">'."\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformtd" colspan=6>'."\n";
if (!$ro)
{
    if ($newimage)
    {
	print '<input type="hidden" name="newimage" value="1">';
	if ($source)
	{
	    print '<input class="adminformbutton" type="submit" name="add" value="'.__("Create").'">'."\n";
	}
    }
    else
    {
	print '<input class="adminformbutton" type="submit" name="modify" value="'.__("Modify").'">'."\n";		
	print '<input class="adminformbutton" type="submit" name="delete" value="'.__("Delete").'" '.$cgi->confirmCode("Do you really want to delete image %s?", $image->{id}).">\n";
    }
}
print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formbottomleft"></td>'."\n";
print '<td colspan=6 class="formbottom"></td>'."\n";
print '<td class="formbottomright"></td>'."\n";
print "</tr>\n";
    
print "</table>\n";
print '<input type="hidden" name="oldwidth" value="'.$image->{width}.'">'."\n";
if ($tmpfile)
{
    print '<input type="hidden" name="tmpfile" value="'.$tmpfile.'">'."\n";
}
print "</form>\n";

if ($source)
{
    print "<table class=\"article\" cellspacing=0 cellpadding=0 border=0>\n";
    print "<tr class=\"articletoptr\">\n";
    print "<td class=\"articletopleft\">\n";
    print "</td>\n";
    print "<td class=\"articletoptd\">\n";
    print "</td>\n";
    print "<td class=\"articletopright\">\n";
    print "</td>\n";
    print "</tr>\n";
    print "<tr class=\"articlebodytr\">\n";
    print "<td class=\"articlebodyleft\">\n";
    print "</td>\n";
    print "<td class=\"articlebodytd\">\n";
    my $style = "";
    if ($image->isDisplayed("Link"))
    {
	$style .= "border-color: blue; border-width: 1px;";
	if ($image->isDisplayed("Border"))
	{
	    $style .= "border-style: solid;";
	}
	else
	{
	    $style .= "border-style: dashed;";
	}
    }
    elsif ($image->isDisplayed("Border"))
    {
	$style .= "border-color: black; border-style: solid; border-width: 1px;";
    }
    else
    {
	$style .= "border: none;";
    }
    my $w;
    my $c;
    for ($w = 0; $w < 50; $w++)
    {
	for ($c = 0; $c < rand(10); $c++)
	{
	    printf("%c", int(97+rand(26)));
	}
	print " ";
    }
    print "\n";
    print '<img name="imgpreview" src="'.$source.'" align="'.$image->{align}.'" style="'.$style.'" width='.$image->{width}.' height='.$image->{height}.'>'."\n";
    for ($w = 0; $w < 800; $w++)
    {
	for ($c = 0; $c < rand(10); $c++)
	{
	    printf("%c", int(97+rand(26)));
	}
	print " ";
    }
    print "\n";
    print "</td>\n";
    print "<td class=\"articlebodyright\">\n";
    print "</td>\n";
    print "</tr>\n";
    print "<tr class=\"articlebottomtr\">\n";
    print "<td class=\"articlebottomleft\">\n";
    print "</td>\n";
    print "<td class=\"articlebottomtd\">\n";
    print "</td>\n";
    print "<td class=\"articlebottomright\">\n";
    print "</td>\n";
    print "</tr>\n";
    print "</table>\n";
}

print $cgi->footerCode();
