#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

my $link;
my $article;
my $newlink = 0;
if ($cgi->{checkurl})
{
    $link = new MN::CMS::Link();
    $link->updateFrom($cgi);
    my $res = $link->checkURL();
    if ($res)
    {
	$cgi->setAlert("URL %s is not OK (error %d)", $link->{url}, $res);
    }
    else
    {
	$cgi->setAlert("URL %s is OK", $link->{url});

    }
    $article = $link->getArticle();
    if ($link->{newlink})
    {
	$newlink = 1;
    }
}
elsif ($cgi->{add} || $cgi->{modify} || $cgi->{delete})
{
    $link = new MN::CMS::Link();
    $link->updateFrom($cgi);
    $article = $link->getArticle();
    if ($cgi->{delete})
    {
	$link->delete();
    }
    elsif ($cgi->{add})
    {
	$link->add();
    }
    else
    {
	$link->modify();
    }
    if ($article->{status} == 4) # published
    {
	$article->{status} = 1; # modified
    }
    $article->setMoDate();
    $article->modify();
    $cgi->redirect("article.cgi?id=$article->{id}");
}
elsif ($cgi->{cmsid})
{
    $link = MN::CMS::Link->getObject($cgi->{cmsid});
    if ($link)
    {
	$article = $link->getArticle();
    }
}
elsif ($cgi->{article})
{
    $link = new MN::CMS::Link();
    $article = MN::CMS::Article->getArticle($cgi->{article});
    $link->{id} = $article->getNextLinkId();
    $newlink = 1;
}

if ($cgi->{cancel})
{
    $link = new MN::CMS::Link();
    $link->updateFrom($cgi);
    $article = $link->getArticle();
    $cgi->redirect("article.cgi?id=$article->{id}");
}

my @navitems = (__("Author"), "/cms/auth", __("Articles"), "/cms/auth/articles.cgi");

push @navitems, $article->{name}, "/cms/auth/article.cgi?id=$article->{id}";

if ($newlink)
{
    push @navitems, __("New link"), "/cms/auth/link.cgi?article=$article->{id}";
}
else
{
    push @navitems, sprintf(__("Link %s"), $link->{id}), "/cms/auth/link.cgi?cmsid=$link->{id}";
}

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

print "<form method=\"post\" name=\"linked\">\n";

my $ro = 0;
if ($article->{status} == 2 || $article->{status} == 3)
{
    $ro = 1;
}

# Name
print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\" class=\"form\">\n";
print "<caption class=\"formtitle\">\n";
if ($newlink)
{
    print __("New link")."\n";
}
else
{
    print sprintf(__("Link %s"), $link->{id})."\n";
}
print "</caption>\n";
print '<tr class="formtr">'."\n";
print '<td class="formtopleft"></td>'."\n";
print '<td colspan=2 class="formtop"></td>'."\n";
print '<td class="formtopright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Link")."\n";
print "</td>\n";
print '<td width="100%" class="formtd">'."\n";
print '<input type="hidden" name="id" value="'.$link->{id}.'">'.$link->{id}."\n";
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Name")."\n";
print "</td>\n";
print '<td width="100%" class="formtd">'."\n";
if ($ro)
{
    print $link->{name}."\n";
}
else
{
    print '<input class="artedname" type="text" name="name" value="'.$cgi->unquote($link->{name}).'" size="100">'."\n";
}
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("URL")."\n";
print "</td>\n";
print '<td width="100%" class="formtd">'."\n";
if ($ro)
{
    print $link->{url}."\n";
}
else
{
    print '<input class="artedname" type="text" name="url" value="'.$cgi->unquote($link->{url}).'" size="100">'."\n";
}
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformtd" colspan=2>'."\n";
print '<hr class="adminformseparator">'."\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformtd" colspan=2>'."\n";
if (!$ro)
{
    print '<input class="adminformbutton" type="submit" name="checkurl" value="'.__("Check URL").'">'."\n";
    my $checkurl = ' onclick="if (window.document.linked.url.value) {return true;} else {alert(\''.__("URL field must be set").'\');return false;}"';
    if ($newlink)
    {
	print '<input type="hidden" name="newlink" value="1">';
	print '<input class="adminformbutton" type="submit" name="add" value="'.__("Create").'"'.$checkurl.'>'."\n";
    }
    else
    {
	print '<input class="adminformbutton" type="submit" name="modify" value="'.__("Modify").'"'.$checkurl.'>'."\n";		
	print '<input class="adminformbutton" type="submit" name="delete" value="'.__("Delete").'" '.$cgi->confirmCode("Do you really want to delete link %s?", $link->{id}).">\n";
	
    }
}
print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formbottomleft"></td>'."\n";
print '<td colspan=2 class="formbottom"></td>'."\n";
print '<td class="formbottomright"></td>'."\n";
print "</tr>\n";
    
print "</table>\n";
print "</form>\n";

print $cgi->footerCode();
