#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

my $note;
my $article;
my $newnote = 0;

if ($cgi->{add} || $cgi->{modify} || $cgi->{delete})
{
    $note = new MN::CMS::Note();
    $note->updateFrom($cgi);
    $article = $note->getArticle();
    if ($cgi->{delete})
    {
	$note->delete();
    }
    elsif ($cgi->{add})
    {
	$note->add();
    }
    else
    {
	$note->modify();
    }
    if ($article->{status} == 4) # published
    {
	$article->{status} = 1; # modified
    }
    $article->setMoDate();
    $article->modify();
    $cgi->redirect("article.cgi?id=$article->{id}");
}
elsif ($cgi->{cmsid})
{
    $note = MN::CMS::Note->getObject($cgi->{cmsid});
    if ($note)
    {
	$article = $note->getArticle();
    }
}
elsif ($cgi->{article})
{
    $note = new MN::CMS::Note();
    $article = MN::CMS::Article->getArticle($cgi->{article});
    $note->{id} = $article->getNextNoteId();
    $newnote = 1;
}

if ($cgi->{cancel})
{
    $note = new MN::CMS::Note();
    $note->updateFrom($cgi);
    $article = $note->getArticle();
    $cgi->redirect("article.cgi?id=$article->{id}");
}

my @navitems = (__("Author"), "/cms/auth", __("Articles"), "/cms/auth/articles.cgi");

push @navitems, $article->{name}, "/cms/auth/article.cgi?id=$article->{id}";

if ($newnote)
{
    push @navitems, __("New note"), "/cms/auth/note.cgi?article=$article->{id}";
}
else
{
    push @navitems, sprintf(__("Note %s"), $note->{id}), "/cms/auth/note.cgi?cmsid=$note->{id}";
}

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

print "<form method=\"post\" name=\"noteed\">\n";

my $ro = 0;
if ($article->{status} == 2 || $article->{status} == 3)
{
    $ro = 1;
}

# Name
print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\" class=\"form\">\n";
print "<caption class=\"formtitle\">\n";
if ($newnote)
{
    print __("New note")."\n";
}
else
{
    print sprintf(__("Note %s"), $note->{id})."\n";
}
print "</caption>\n";
print '<tr class="formtr">'."\n";
print '<td class="formtopleft"></td>'."\n";
print '<td colspan=2 class="formtop"></td>'."\n";
print '<td class="formtopright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Note")."\n";
print "</td>\n";
print '<td width="100%" class="formtd">'."\n";
print '<input type="hidden" name="id" value="'.$note->{id}.'">'.$note->{id}."\n";
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Content")."\n";
print "</td>\n";
print '<td width="100%" class="formtd">'."\n";
if ($ro)
{
    print $note->{body}."\n";
}
else
{
    print '<textarea name="body" class="artedbody" rows="2" cols="80">'."\n";
    print $note->{body}."\n";
    print "</textarea>\n";
}
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Link")."\n";
print "</td>\n";
print '<td width="100%" class="formtd">'."\n";
if ($ro)
{
    print $note->getLink()."\n";
}
else
{
    print $article->noteLinkSelectorCode($note->{link})."\n";
}
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformtd" colspan=2>'."\n";
print '<hr class="adminformseparator">'."\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformtd" colspan=2>'."\n";
if (!$ro)
{
    if ($newnote)
    {
	print '<input type="hidden" name="newnote" value="1">';
	print '<input class="adminformbutton" type="submit" name="add" value="'.__("Create").'">'."\n";
    }
    else
    {
	print '<input class="adminformbutton" type="submit" name="modify" value="'.__("Modify").'">'."\n";		
	print '<input class="adminformbutton" type="submit" name="delete" value="'.__("Delete").'" '.$cgi->confirmCode("Do you really want to delete note %s?", $note->{id}).">\n";
	
    }
}
print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formbottomleft"></td>'."\n";
print '<td colspan=2 class="formbottom"></td>'."\n";
print '<td class="formbottomright"></td>'."\n";
print "</tr>\n";
    
print "</table>\n";
print "</form>\n";

print $cgi->footerCode();
