CREATE TABLE "mnarticle" (
   "id" varchar(255) NOT NULL,
   "name" text,
   "template" varchar(32),
   "topic" varchar(100),
   "abstract" text,
   "body" text,
   "author" varchar(100),
   "moderator" varchar(100),
   "crdate" date,
   "crtime" time,
   "modate" date,
   "motime" time,
   "status" int2,
   "cycle" int2,
   CONSTRAINT "mnarticle_pkey" PRIMARY KEY ("id")
);
CREATE INDEX "motime_mnarticle_key" ON "mnarticle" ("motime");
CREATE INDEX "modate_mnarticle_key" ON "mnarticle" ("modate");
CREATE INDEX "template_mnarticle_key" ON "mnarticle" ("template");

CREATE TABLE "mnprivilege" (
   "template" varchar(32) NOT NULL,
   "user" varchar(100) NOT NULL,
   "role" int2 NOT NULL,
   CONSTRAINT "mnprivilege_pkey" PRIMARY KEY ("user", "template", "role")
);

CREATE TABLE "mnlink" (
   "id" varchar(255) NOT NULL,
   "name" text,
   "url" text,
   CONSTRAINT "mnlink_pkey" PRIMARY KEY ("id")
);

CREATE TABLE "mnnote" (
   "id" varchar(255) NOT NULL,
   "body" text,
   "link" int2,
   CONSTRAINT "mnnote_pkey" PRIMARY KEY ("id")
);

CREATE TABLE "mnimage" (
   "id" varchar(255) NOT NULL,
   "name" text,
   "width" int2,
   "height" int2,
   "align" varchar(10),
   "swidth" int2,
   "sheight" int2,
   "display" int8,
   CONSTRAINT "mnimage_pkey" PRIMARY KEY ("id")
);
