#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my $user = $cgi->getUser();
my @navitems = ();

my $image = MN::CMS::Image->getObject($cgi->{cmsid});
if (!$image)
{
    $cgi->error("Image %s doesn't exist", $cgi->{cmsid});
}
my $cmsid = $cgi->{cmsid};
$cmsid =~ s/\_\d+$//;
my $article = MN::CMS::Article->getArticle($cmsid);
if (!$article)
{
    $cgi->error("Article %s doesn't exist", $cmsid);
}
my $access = 0;
if ($article->{status} == 4)
{
    $access = 1;
}
else
{
    if ($user && ($user->{login} eq $article->{author} || $user->{login} eq $article->{moderator}))
    {
	$access = 1;
    }    
}
if (!$access)
{
    $cgi->error("Article is not accessible for the moment");
}

my $tmpl = $article->getTemplate();

if (!$tmpl)
{
    $cgi->error("Template %s doesn't exist", $article->{template})
}

if ($user && !MN::Subscr->getObject($tmpl->{id}, $user->{login}))
{
    push @navitems, __("Other sites"), "/other.cgi";
}
push @navitems, $tmpl->{name}, "/template.cgi?id=$tmpl->{id}";

if ($article->{topic})
{
    my $topic = $article->getTopic();

    if (!$topic)
    {
	$cgi->error("Topic %s doesn't exist", $article->{topic});
    }
    push @navitems, $topic->{name}, "/topic.cgi?id=$topic->{id}";
}
my $max = 60;
my $name = $article->{name};
if (length($name) > $max)
{
    $name = substr($name, 0, $max);
    $name =~ s/\s\S*$/\.\.\./;
}
push @navitems, $name, "/cms/article.cgi?cmsid=$article->{id}";

$name = $image->{name};
if ($name)
{
    if (length($name) > $max)
    {
	$name = substr($name, 0, $max);
	$name =~ s/\s\S*$/\.\.\./;
    }
    push @navitems, $name, "/cms/image.cgi?cmsid=$image->{id}";
}

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

print $article->getCode($image->getCode(1));

print $cgi->footerCode();
