#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my $article;

if ($cgi->{cancel})
{
    $cgi->redirect("articles.cgi");
}
elsif ($cgi->{publish} && $cgi->{id})
{
    $article = MN::CMS::Article->getObject($cgi->{id});
    if ($article)
    {
	my $res = $article->publish($cgi->{comment});

	if ($res)
	{
	    $cgi->setAlert($res);
	}
	else
	{
	    $cgi->setAlert("Article %s has been published", $cgi->{id});
	}
    } 
}
elsif ($cgi->{sendback} && $cgi->{id})
{
    $article = MN::CMS::Article->getObject($cgi->{id});
    if ($article)
    {
	my $res = $article->sendback($cgi->{comment});

	if ($res)
	{
	    $cgi->setAlert($res);
	}
	else
	{
	    $cgi->setAlert("Article %s has been sent back to author for modification", $cgi->{id});
	}
    } 
}

my @navitems = (__("Moderator"), "/cms/mod", __("Articles"), "/cms/mod/articles.cgi");

if ($cgi->{id})
{
    $article = MN::CMS::Article->getObject($cgi->{id});
}
else
{
    $article = new MN::CMS::Article();
    $article->updateFrom($cgi);
}

my $user = $cgi->getUser();

if (!$user->isModeratorFor($article->{template}))
{
    $cgi->error("You are not moderator for this section");
}

push @navitems, $article->{name}, "/cms/mod/article.cgi?id=$article->{id}";

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

print "<form method=\"post\" name=\"arted\">\n";

print_form();

print "<p>\n";

print $article->getCode("", $mne->{conf}->{weburl}.'/cms/article.cgi?cmsid='.$article->{id});

print "</form>\n";

print $cgi->footerCode();

sub print_form
{
    my $tmpl = $article->getTemplate();

    print '<input type="hidden" name="id" value="'.$article->{id}.'">'."\n";

    print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\"class=\"form\">\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formtopleft"></td>'."\n";
    print '<td colspan=5 class="formtop"></td>'."\n";
    print '<td class="formtopright"></td>'."\n";
    print "</tr>\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td width="20%" class="formlabel">'."\n";
    print __("Article")."\n";
    print "</td>\n";
    print '<td width="20%" class="formtd">'."\n";
    print $article->{id};
    print "</td>\n";
    print '<td width="20%" class="formlabel">'."\n";
    print __("Status")."\n";
    print "</td>\n";
    print '<td width="20%" class="formtd">'."\n";
    print $article->getStatus();
    print "</td>\n";
    print '<td width="20%" class="formtd">'."\n";
    if (($article->{status} == 2 || 
	$article->{status} == 3) && $tmpl->isModerated())
    {
	my $checkcomment = ' onclick="if (window.document.arted.comment.value) {return confirm(\''.__("Confirm return to author").'\')} else {alert(\''.__("Comment field must be set").'\');return false;}"';

	print '<input class="adminformbutton2" type="submit" name="sendback"'.$checkcomment.' value="'.__("Send back to author").'">'."\n";
    }
    else
    {
	print "&nbsp;";
    }
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Author")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $article->getAuthor();
    print "</td>\n";
    print '<td class="formlabel">'."\n";
    print __("Moderator")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $article->getModerator();
    print "</td>\n";
    print '<td class="formtd">'."\n";
    if (($article->{status} == 2 || 
	$article->{status} == 3) && $tmpl->isModerated())
    {
	print '<input class="adminformbutton2" type="submit" name="publish" value="'.__("Publish article").'" onclick="return confirm(\''.__("Confirm publication").'\')">'."\n";
    }
    else
    {
	print "&nbsp;";
    }
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Creation date")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $article->getDate()."&nbsp;".$article->getTime();
    print "</td>\n";
    print '<td class="formlabel">'."\n";
    print __("Last update")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $article->getDate(1)."&nbsp;".$article->getTime(1);
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print "&nbsp;";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Section")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    if ($tmpl)
    {
	print $tmpl->{name}."\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";
    print '<td class="formlabel">'."\n";
    print __("Topic")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    my $topic = $article->getTopic();
    if ($topic)
    {
	print $topic->{name}."\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td colspan=5 class="formtd" align="center">'."\n";
    print "<b>".__("Comment")."</b>\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";
    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td colspan=5 class="formtd">'."\n";
    print '<textarea name="comment" class="artedbody" rows="2" cols="80">'."\n";
    print "</textarea>\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";
    
    print '<tr class="formtr">'."\n";
    print '<td class="formbottomleft"></td>'."\n";
    print '<td colspan=5 class="formbottom"></td>'."\n";
    print '<td class="formbottomright"></td>'."\n";
    print "</tr>\n";
    print "</table>\n";
}
