#!/usr/bin/perl

use strict;
use MN 1.1;
use MN::CMS 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my @navitems = (__("Moderator"), "/cms/mod", __("Articles"), "/cms/mod/articles.cgi");
if ($cgi->{template})
{
    my $tmpl = MN::Template->getTemplate($cgi->{template});
    push @navitems, $tmpl->{name}, "/cms/mod/articles.cgi?template=$cgi->{template}";
}
elsif ($cgi->{topic})
{
    my $topic = MN::Topic->getTopic($cgi->{topic});
    my $tmpl = $topic->getTemplate();
    push @navitems, $tmpl->{name}, "/cms/mod/articles.cgi?template=$tmpl->{id}";
    push @navitems, $topic->{name}, "/cms/mod/articles.cgi?topic=$cgi->{topic}";
}
elsif (defined $cgi->{status})
{
    push @navitems, __("_status_".$cgi->{status}), "/cms/mod/articles.cgi?status=$cgi->{status}";
}

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

my $user = $cgi->getUser();

my $sections = $user->getModSections();
my $section;
my $str = "";
my $sep = "";
foreach $section (@{$sections})
{
    $str .= $sep."'$section->{id}'";
    $sep = ",";
}

my $filter = "((moderator = '$user->{login}') or (template in ($str) and status in (2,3))) ";
if ($cgi->{template})
{
    $filter .= " and template='$cgi->{template}'";
}
elsif ($cgi->{topic})
{
    $filter .= " and topic='$cgi->{topic}'";
}
elsif (defined $cgi->{status})
{
    if ($cgi->{status} == 2 || $cgi->{status} == 3)
    {
	$filter .= " and status in (2,3)";
    }
    else
    {
	$filter .= " and status = $cgi->{status}";
    }
}

my $nbn = MN::CMS::Article->getObjectsCount($filter);
my $npp = 20;
my $fbp = ($nbn / $npp);
my $nbp = int($fbp);
if ($nbp < $fbp || $nbp == 0) { $nbp++ ; }
my $offset = 0;
if ($cgi->{page} > 1)
{
    $offset = ($cgi->{page} - 1) * $npp;
}
my @articles = MN::CMS::Article->getObjects($filter, "status, crdate desc, crtime desc", $npp, $offset);

print "<form method=\"post\">\n";
print "<div class=\"adminpage\">\n";
print '<div class="adminpagelabel">'.__("Page")."</div>\n";
print '<select class="adminpageselect" name="page" onchange="form.submit();">'."\n";
my $i;
for ($i = 1; $i <= $nbp; $i++)
{
    print '<option value="'.$i.'"';
    if ($i == $cgi->{page})
    {
	print " selected";
    }
    print '>'.$i."\n";
}
print "</select>\n";
print "&nbsp;";
printf(__("of %d"), $nbp);
print "</div>\n";
if ($cgi->{template})
{
    print '<input type="hidden" name="template" value="'.$cgi->{template}.'">'."\n";
}
elsif ($cgi->{topic})
{
    print '<input type="hidden" name="topic" value="'.$cgi->{topic}.'">'."\n";
}
elsif (defined $cgi->{status})
{
    print '<input type="hidden" name="status" value="'.$cgi->{status}.'">'."\n";
}
print "</form>\n";
print "<br clear=all>\n";
print "<form method=\"post\" name=\"articles\">\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
print "<caption class=\"admintbtitle\">\n";
print __("My moderations")."\n";
print "</caption>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrtopleft">'."</td>\n";
print '<td class="admintbrtop">'."</td>\n";
print '<td class="admintbrtopright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrleft">'."</td>\n";
print '<td class="admintbr">'."\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
print '<tr class="adminheadertr">'."\n";
print '<td class="adminnumbertd2" title="';
if ($nbn > 1)
{
    printf(__("%d articles"), $nbn);
}
else
{
    printf(__("%d article"), $nbn);
}
print '">'."#"."</td>\n";
print '<td class="adminheadertd">'.__("Article")."</td>\n";
if (defined $cgi->{status})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All status").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Status");
if ($cgi->{topic})
{
    print '</a>';
}
print "</td>\n";
print '<td class="adminheadertd">';
print __("Creation date");
print "</td>\n";
print '<td class="adminheadertd">';
print __("Last update");
print "</td>\n";
if ($cgi->{template})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All sections").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Section");
if ($cgi->{template})
{
    print '</a>';
}
print "</td>\n";
if ($cgi->{topic})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="articles.cgi" title="'.__("All topics").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Topic");
if ($cgi->{topic})
{
    print '</a>';
}
print "</td>\n";
print "</tr>\n";
my $row = "odd";
my $article;
my $tmpl;
my $topic;
my $n = $offset;
foreach $article (@articles)
{
    print '<tr class="admin'.$row.'tr">'."\n";

    # number
    print '<td class="adminnumbertd">';
    $n++;
    print $n."\n";
    print "</td>\n";

    # title
    print '<td class="admin'.$row.'td">';
    print '<a href="/cms/mod/article.cgi?id='.$article->{id}.'">'.$article->{name}."</a>\n";
    print "</td>\n";

    # status
    print '<td class="admin'.$row.'td">';
    print '<a href="articles.cgi?status='.$article->{status}.'">'.$article->getStatus()."</a>\n";
    print "</td>\n";

    # creation date
    print '<td class="admin'.$row.'td">';
    print $article->getDate() ."&nbsp;".$article->getTime()."\n";
    print "</td>\n";

    # modification date
    print '<td class="admin'.$row.'td">';
    print $article->getDate(1) ."&nbsp;".$article->getTime(1)."\n";
    print "</td>\n";

    # template
    print '<td class="admin'.$row.'td">';
    $tmpl = $article->getTemplate();
    if ($tmpl)
    {
	print '<a href="articles.cgi?template='.$article->{template}.'">'.$tmpl->{name}."</a>\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";

    # topic
    print '<td class="admin'.$row.'td">';
    $topic = $article->getTopic();
    if ($topic)
    {
	print '<a href="articles.cgi?topic='.$article->{topic}.'">'.$topic->{name}."</a>\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";

    print "</tr>\n";
    $row = $row eq "odd" ? "even" : "odd";
}
print "</table>\n";
print "</td>\n";
print '<td class="admintbrright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrbottomleft">'."</td>\n";
print '<td class="admintbrbottom">'."</td>\n";
print '<td class="admintbrbottomright">'."</td>\n";
print "</tr>\n";
print "</table>\n";
if ($cgi->{template})
{
    print '<input type="hidden" name="template" value="'.$cgi->{template}.'">'."\n";
}
elsif ($cgi->{topic})
{
    print '<input type="hidden" name="topic" value="'.$cgi->{topic}.'">'."\n";
}
elsif (defined $cgi->{status})
{
    print '<input type="hidden" name="status" value="'.$cgi->{status}.'">'."\n";
}
print "</form>\n";

print $cgi->footerCode();
